#include "analog_sensor.h"

#include <Arduino.h>

#include <limits.h>

AnalogSensor::AnalogSensor(uint8_t const pin)
  : pin_{ pin }, value_{ INT_MIN }, previousValue_{ INT_MIN } {}

void AnalogSensor::init() noexcept {
}

void AnalogSensor::update(unsigned long deltaMillis) noexcept {
  previousValue_ = value_;
  value_ = analogRead(pin_);
}

bool AnalogSensor::hasValueChanged() const noexcept {
  return previousValue_ != value_;
}

int AnalogSensor::getValue() const noexcept {
  return value_;
}
