#pragma once

#include "node.h"

// uint8_t
#include <stdint.h>

class AnalogSensor final : public Node {
public:
  explicit AnalogSensor(uint8_t pin) noexcept;

  void init() noexcept override;
  void update(unsigned long deltaMillis) noexcept override;

  bool hasValueChanged() const noexcept;
  int getValue() const noexcept;

private:
  uint8_t pin_;
  int value_, previousValue_;
};
