#include "node.h"

void AbstractNode::init() noexcept {
  NodeList& children = getChildren();
  for (size_t n = children.size(); n--;) {
    children.get(n)->init();
  }
}

void AbstractNode::update(unsigned long deltaMillis) noexcept {
  NodeList& children = getChildren();
  for (size_t n = children.size(); n--;) {
    children.get(n)->update(deltaMillis);
  }
}
